<?
/**
 * This is DokuWiki's Main Configuration file
 *
 * This is a piece of PHP code so PHP syntax applies!
 */

$conf['umask']       = 0111; //set the umask for new files
$conf['dmask']       = 0000; //directory mask accordingly

$conf['lang']        = 'en';              //your language
$conf['datadir']     = './data';          //where to store the data
$conf['olddir']      = './attic';         //where to store old revisions
$conf['mediadir']    = './media';         //where to store media files
$conf['mediaweb']    = 'media';           //access to media from the web
$conf['changelog']   = './changes.log';   //change log

$conf['start']       = 'start';           //name of start page
$conf['title']       = 'DokuWiki';        //what to show in the title

$conf['usewordblock']= 1;          //block spam based on words? 0|1

$conf['mailguard']   = 'hex';      //obfuscate email addresses against spam harvesters?
                                   //valid entries are:
                                   //  'visible' - replace @ with [at], . with [dot] and - with [dash]
                                   //  'hex'     - use hex entities to encode the mail address
                                   //  'none'    - do not obfuscate addresses

$conf['userewrite']  = 0;  //this makes nice URLs but you need to enable it in .htaccess first 0|1
$conf['fullpath']    = 0;  //show full path of the document or relative to datadir only? 0|1
$conf['usegzip']     = 1;  //gzip old revisions? You'll need zdiff too. 0|1

$conf['recent']      = 20; //how many entries to show in recent
$conf['breadcrumbs'] = 10; //how many recent visited pages to show
$conf['maxtoclevel'] = 3;  //Up to which level include into AutoTOC (max. 5)
$conf['maxseclevel'] = 3;  //Up to which level create editable sections (max. 5)

$conf['cachetime']   = 60*60*24*7;   //maximum age for cachefile in seconds (defaults to a week)
$conf['purgeonadd']  = 1;            //purge cache when a new file is added
                                     //(needed for up to date links)

$conf['grep']        = 'grep';       //path to GNU grep
$conf['sort']        = 'sort';       //path to GNU sort
$conf['find']        = 'find';       //path to GNU find
$conf['diff']        = 'diff';       //path to GNU diff
$conf['zdiff']       = 'zdiff';      //path to GNU zdiff (part of gzip)

$conf['typography']  = 1;  //convert quotes, dashes and stuff to typographic equivalents? 0|1
$conf['htmlok']      = 0;  //may raw HTML be embedded? This may break layout and XHTML validity 0|1
$conf['phpok']       = 0;  //may PHP code be embedded? Never do this on the internet! 0|1

$conf['dformat']     = 'd.m.Y H:i';  //dateformat accepted by PHPs date() function

//DokuWiki can send diff's on every change to this email address
//comment it out to disable this feature
#$conf['notify']      = 'admin@example.com';

//Set target to use when creating links - leave empty for same window
$conf['target']['wiki']      = '';
$conf['target']['interwiki'] = '_blank';
$conf['target']['extern']    = '_blank';
$conf['target']['media']     = '';
$conf['target']['windows']   = '';

?>
