<?
include_once("inc/format.php");

function html_wikilink($link,$name=''){
  format_link_wiki($link,$name,$class,$target,$style,$pre,$post,$more);
  // build the replacement with the variables set by the formaters
  $ret .= $pre;
  $ret .= '<a href="'.$link.'"';
  if($class)  $ret .= ' class="'.$class.'"';
  if($target) $ret .= ' target="'.$target.'"';
  if($style)  $ret .= ' style="'.$style.'"';
  if($more)   $ret .= ' '.$more;
  $ret .= '>';
  $ret .= $name;
  $ret .= '</a>';
  $ret .= $post;

  return $ret;
}

function html_breadcrumbs(){
  global $lang;
  
  $crumbs = breadcrumbs(); //setup crumb trace
  print '<div class="breadcrumbs">';
  print $lang['breadcrumb'].':';
  foreach ($crumbs as $crumb){
    print ' &raquo; ';
    print '<a href="'.wl($crumb).'" class="breadcrumbs">'.$crumb.'</a>';
  }
  print '</div>';
}

function html_head(){
  global $ID;
  global $ACT;
  global $conf;
  global $lang;
  $fn = wikiFN($ID);
  
  print '<'.'?xml version="1.0"?'.">\n";
  print '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"';
  print ' "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">';
  print "\n";
?>
  <html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?=$conf['lang']?>" lang="<?=$conf['lang']?>" dir="ltr">
  <head>
    <title><?=$conf['title']?><?if($ID) print ": $ID";?></title>
    <meta http-equiv="Content-Type" content="text/html; charset=<?=$lang['encoding']?>" />
    <meta name="generator" content="DokuWiki" />
    <link rel="stylesheet" media="screen" type="text/css" href="style.css" />
    <link rel="stylesheet" media="print" type="text/css" href="print.css" />
    <link rel="shortcut icon" href="images/favicon.ico" />
    <link rel="Start" href="<?=wl()?>" />
    <link rel="alternate" type="application/rss+xml" title="RSS" href="feed.php" />
<?
  if($ACT=='show'){
    if(file_exists($fn)){
      print '    <meta name="robots" content="index,follow" />'."\n";
      print '    <meta name="date" content="'.date('Y-m-d\TH:i:sO',filemtime($fn)).'" />'."\n";
    }else{
      print '    <meta name="robots" content="noindex,follow" />';
    }
  }else{
    print '    <meta name="robots" content="noindex,nofollow" />';
  }
?>
    <script language="JavaScript" type="text/javascript" src="script.js"></script>

    <!--[if gte IE 5]>
    <style type="text/css">
      /* that IE 5+ conditional comment makes this only visible in IE 5+ */
      img { behavior: url("pngbehavior.htc"); } /* IE bugfix for transparent PNGs */
    </style>
    <![endif]-->

  </head>
<?
}

function html_header(){
  global $ID;
  global $REV;
  global $lang;
  global $conf;
  html_head();
?>
  <body>
	<table class="logo">
    <tr>
      <td class="logo-left">
        [[<a href="<?=wl($ID)?>" class="id"><?=$ID?></a>]]
      </td>
      <td class="logo-right">
        <a href="<?=wl()?>" class="logo" name="top" accesskey="h" title="[ALT+H]"><?=$conf['title']?></a>
      </td>
    </tr>
  </table>
  <table class="header">
    <tr>
      <td class="header-left">
        <a href="<?=wl($ID,"rev=$REV,do=edit")?>" class="button" accesskey="e" title="[ALT+E]"><?=$lang['btn_edit']?></a>
        <a href="<?=wl($ID,"do=revisions")?>" class="button" accesskey="r" title="[ALT+R]"><?=$lang['btn_revs']?></a>
      </td>
      <td class="header-right">
        <form action="<?=wl()?>" accept-charset="<?=$lang['encoding']?>">
          <a href="<?=wl('','do=recent')?>" class="button"><?=$lang['btn_recent']?></a>
          <input type="hidden" name="do" value="search" />
          <input type="text" name="id" class="edit" />
          <input type="submit" value="<?=$lang['btn_search']?>" class="button" />
        </form>
      </td>
    </tr>
  </table>
  <?html_breadcrumbs()?>
  <div class="page">
  <!-- wikipage start -->
<?
}

function html_footer(){
  global $ID;
  global $REV;
  global $lang;
  global $conf;
  $fn   = @realpath(wikiFN($ID,$REV));
  if($conf['fullpath']){
    $fn = @realpath(wikiFN($ID,$REV));
  }else{
    $fn = wikiFN($ID,$REV);
    $fn = str_replace('./','',$fn);
  }
  $date = @date($conf['dformat'],@filemtime($fn));
?>
  <!-- wikipage stop -->
  </div>
  <div class="meta">
    <?if($fn){?><?=$fn?> <?=$lang['lastmod']?>: <?=$date?><?}?>
  </div>
  <table class="footer">
    <tr>
      <td class="footer-left">
        <a href="<?=wl($ID,"rev=$REV,do=edit")?>" class="button" title="[ALT+E]"><?=$lang['btn_edit']?></a>
        <a href="<?=wl($ID,"do=revisions")?>" class="button" title="[ALT+R]"><?=$lang['btn_revs']?></a>
      </td>
      <td class="footer-right">
        <a href="<?=wl($ID,"do=index")?>" class="button" title="[ALT+X]" accesskey="x"><?=$lang['btn_index']?></a>
        <a href="#top" class="button"><?=$lang['btn_top']?></a>
      </td>
    </tr>
  </table>
  <?@include("footer.html")?>
  </body>
  </html>
<?
}

function html_toc($toc){
  global $lang;
  $ret  = '';
  $ret .= '<table class="toc">';
  $ret .= '<tr><th class="toc">'.$lang['toc'];
  $ret .= ' <script type="text/javascript">';
  $ret .= 'showTocToggle("+","-")';
  $ret .= '</script>';
  $ret .= '</th></tr>';
  $ret .= '<tr id="tocinside"><td class="toc">';
  foreach($toc as $t){
    $ret .= '<div class="toc'.$t['level'].'">';
    $ret .= '&middot;<a href="#'.$t['id'].'" class="toc">';
    $ret .= $t['name'];
    $ret .= '</a></div>';
  }
  $ret .= '</td></tr>';
  $ret .= '</table>';
  return $ret;
}

function html_show($text=''){
  global $ID;
  global $REV;
  //disable section editing for old revisions or in preview
  if($text || $REV){
    global $parser;
    $parser['secedit'] = false;
  }

  if ($text){
    //PreviewHeader
    print parsedLocale('preview');
    print '<div class="preview">';
    print parse($text);
    print '</div>';
  }else{
    if ($REV) print parsedLocale('showrev');
    print parsedWiki($ID,$REV,true);
  }
}

function html_search(){
  global $ID;
  global $lang;
  print parsedLocale('searchpage');
  $qhits = quicksearch($ID);
  if(count($qhits)){
    print '<div class="search_quickhits">';
    print '<b>'.$lang[quickhits].':</b><br>';
    foreach($qhits as $id){
      print '<img src="images/bullet.gif" alt="-" class="search_quickhits">&nbsp;';
      print html_wikilink($id);
      print ' ';
    }
    print '</div>';
  }
  fulltextsearch($ID);
  print '<p></p>';
}

function html_result($id,$cnt,$q,$snip){
  global $lang;
  $snip = formText($snip);
  $snip = str_replace("\n--\n",'<span class="search_sep"> ... </span>',$snip);
  $snip = preg_replace('/('.str_replace('/','\/',$q).')/i','<span class="search_hit">\1</span>',$snip);
  $snip = '<span class="search_sep"> ... </span>'.$snip.'<span class="search_sep"> ... </span>';
?>
  <div class="search_result">
    <?=html_wikilink($id)?>:  <span class="search_cnt"><?=$cnt?> <?=$lang['hits']?></span><br />
    <div class="search_snippet"><?=$snip?></div>
  </div>
<?
}

function html_revisions(){
  global $ID;
  global $conf;
  global $lang;
  $revisions = getRevisions($ID); 
  $date = @date($conf['dformat'],@filemtime(wikiFN($ID)));
  
  print parsedLocale('revisions');
  print '<ul>';
  print '<li>'.$date.' <a class="wikilink1" href="'.wl($ID).'">'.$ID.'</a> ('.$lang['current'].')</li>';
  
  foreach($revisions as $rev){
    $date = date($conf['dformat'],$rev);
    print '<li>';
    print $date.' <a class="wikilink1" href="'.wl($ID,"rev=$rev").'">'.$ID.'</a> ';
    print '<a href="'.wl($ID,"rev=$rev,do=diff").'">['.$lang['diff'].']</a>';
    print '</li>';
  }
  print '</ul>';
}

function html_recent(){
  global $conf;
  global $lang;
  $recents = getRecents();

  print parsedLocale('recent');
  print '<ul>';
  foreach(array_keys($recents) as $id){
    $date = date($conf['dformat'],$recents[$id]['date']);
    print '<li>';
    print $date.' '.html_wikilink($id);
    print ' <span class="user">(';
    print $recents[$id]['ip'];
    if($recents[$id]['user']) print ' '.$recents[$id]['user'];
    print ')</span>';
    print '</li>';
  }
  print '</ul>';
}

function html_index($ns){
  global $conf;
  global $ID;
  $dir = $conf['datadir'];
  $ns  = cleanID($ns);
  if(empty($ns)){
    $ns = dirname(str_replace(':','/',$ID));
    if($ns == '.') $ns ='';
  }
  $ns  = str_replace(':','/',$ns);

  print parsedLocale('index');
  
  print "\n";
  print '<ul class="idx">';
  recursedir($dir,"/$ns",'html_index_pfile','html_index_pdir','\.txt');
  print '</ul>';
  print "\n";

}

function html_index_pdir($base,$file,$lvl,$in,$sub){
  global $ID;
  if(empty($file)) return;
  if($in){
    $ns = $base;
    $ns = str_replace('/',':',$ns);

    print '<li class="level'.$lvl.'">';
    print '<a href="'.wl($ID,'idx='.$ns).'" class="idx_dir">';
    print $file;
    print '</a>';
    if($sub) print '<ul class="idx">';
    print "\n";
  }else{
    if($sub) print '</ul>';
    print '</li>';
    print "\n";
  }
}
  
function html_index_pfile($base,$file,$lvl){
  if(empty($file)) return;
  $wl = $base.'/'.$file;
  $wl = str_replace('/',':',$wl);
  $wl = preg_replace('#\.txt$#','',$wl);

  print '<li class="level'.$lvl.'">';
  print html_wikilink($wl); 
  print '</li>';
  print "\n";
} 

function html_diff($text='',$intro=true){
  require_once("inc/DifferenceEngine.php");
  global $ID;
  global $REV;
  global $lang;
  global $conf;
  if($text){
    $df  = new Diff(split("\n",htmlspecialchars(rawWiki($ID,''))),
                    split("\n",htmlspecialchars(cleanText($text))));
    $left  = '<a class="wikilink1" href="'.wl($ID).'">'.
              $ID.' '.date($conf['dformat'],@filemtime(wikiFN($ID))).'</a>'.
              $lang['current'];
    $right = $lang['yours'];
  }else{
    $df  = new Diff(split("\n",htmlspecialchars(rawWiki($ID,$REV))),
                    split("\n",htmlspecialchars(rawWiki($ID,''))));
    $left  = '<a class="wikilink1" href="'.wl($ID,"rev=$REV").'">'.
              $ID.' '.date($conf['dformat'],$REV).'</a>';
    $right = '<a class="wikilink1" href="'.wl($ID).'">'.
              $ID.' '.date($conf['dformat'],@filemtime(wikiFN($ID))).'</a> '.
              $lang['current'];
  }
  $tdf = new TableDiffFormatter();
  if($intro) print parsedLocale('diff');
  ?>
    <table class="diff" width="100%">
      <tr>
        <td colspan="2" width="50%" class="diff-header">
          <?=$left?>
        </td>
        <td colspan="2" width="50%" class="diff-header">
          <?=$right?>
        </td>
      </tr>
      <?=$tdf->format($df)?>
    </table>
  <?
}

function html_conflict($text){
  global $ID;
  global $lang;

  print parsedLocale('conflict');
  ?>
  <form name="editform" method="post" action="<?=script()?>" accept-charset="<?=$lang['encoding']?>">
  <input type="hidden" name="id" value="<?=$ID?>" />
  <input type="hidden" name="wikitext" value="<?=urlencode($text)?>" />
  
  <div align="center">
    <input class="button" type="submit" name="do" value="<?=$lang['btn_save']?>" accesskey="s" title="[ALT+S]" />
    <a href="<?=wl($ID)?>" class="button"><?=$lang['btn_cancel']?></a>
  </div>
  </form>
  <br /><br /><br /><br />
  <?
}

function html_edit($text='',$include='edit'){ //FIXME: include needed?
  global $ID;
  global $REV;
  global $DATE;
  global $RANGE;
  global $PRE;
  global $SUF;
  global $lang;
  global $conf;

  //no text? Load it!
  if(!$text){
    if($RANGE){
      list($PRE,$text,$SUF) = rawWikiSlices($RANGE,$ID,$REV);
    }else{
      $text = rawWiki($ID,$REV);
    }
  }

  $file = wikiFN($ID);
  $wr = (!file_exists($file) || is_writable($file));
  if($wr){
    if ($REV) print parsedLocale('editrev');
    print parsedLocale($include);
  }else{
    print parsedLocale('read');
    $ro='readonly="readonly"';
  }
  if(!$DATE) $DATE = @filemtime($file);
?>
  <form name="editform" method="post" action="<?=script()?>" accept-charset="<?=$lang['encoding']?>">
  <input type="hidden" name="id"   value="<?=$ID?>" />
  <input type="hidden" name="rev"  value="<?=$REV?>" />
  <input type="hidden" name="date" value="<?=$DATE?>" />
  <input type="hidden" name="prefix" value="<?=urlencode($PRE)?>" />
  <input type="hidden" name="suffix" value="<?=urlencode($SUF)?>" />
  <table style="width:99%">
    <tr>
      <td class="toolbar" colspan="2">
        <?if($wr){?>
        <script language="JavaScript" type="text/javascript">
          addButton('images/bold.png','<?=$lang['qb_bold']?>','**','**','<?=$lang['qb_bold']?>','b');
          addButton('images/italic.png','<?=$lang['qb_italic']?>',"\/\/","\/\/",'<?=$lang['qb_italic']?>','i');
          addButton('images/underline.png','<?=$lang['qb_underl']?>','__','__','<?=$lang['qb_underl']?>','u');
          addButton('images/code.png','<?=$lang['qb_code']?>','\'\'','\'\'','<?=$lang['qb_code']?>','c');

          addButton('images/fonth1.png','<?=$lang['qb_h1']?>','====== ',' ======\n','<?=$lang['qb_h1']?>','1');
          addButton('images/fonth2.png','<?=$lang['qb_h2']?>','===== ',' =====\n','<?=$lang['qb_h2']?>','2');
          addButton('images/fonth3.png','<?=$lang['qb_h3']?>','==== ',' ====\n','<?=$lang['qb_h3']?>','3');
          addButton('images/fonth4.png','<?=$lang['qb_h4']?>','=== ',' ===\n','<?=$lang['qb_h4']?>','4');
          addButton('images/fonth5.png','<?=$lang['qb_h5']?>','== ',' ==\n','<?=$lang['qb_h5']?>','5');

          addButton('images/link.png','<?=$lang['qb_link']?>','[[',']]','<?=$lang['qb_link']?>','l');
          addButton('images/extlink.png','<?=$lang['qb_extlink']?>','[[',']]','http://www.example.com|<?=$lang['qb_extlink']?>');

          addButton('images/rule.png','<?=$lang['qb_hr']?>','----\n','','');

          addButton('images/list.png','<?=$lang['qb_ol']?>','  - ','\n','<?=$lang['qb_ol']?>');
          addButton('images/list_ul.png','<?=$lang['qb_ul']?>','  * ','\n','<?=$lang['qb_ul']?>');

          addMediaSelect('images/image.png','<?=$lang['qb_media']?>','m');
          addInfobox('Click a button to get an example text','Please enter the text you want to be formatted.\\n It will be shown in the infobox for copy and pasting.\\nExample:\\n$1\\nwill become:\\n$2');
        </script>
        <?}?>
      </td>
    </tr>
    <tr>
      <td colspan="2">
        <textarea name="wikitext" id="wikitext" <?=$ro?> cols="80" rows="10" class="edit"><?="\n".formText($text)?></textarea>
      </td>
    </tr>
    <tr>
      <td>
      <?if($wr){?>
        <input class="button" type="submit" name="do" value="<?=$lang['btn_save']?>" accesskey="s" title="[ALT+S]" />
        <input class="button" type="submit" name="do" value="<?=$lang['btn_preview']?>" accesskey="p" title="[ALT+P]" />
        <a href="<?=wl($ID)?>" class="button"><?=$lang['btn_cancel']?></a>
      <?}?>
      </td>
      <td align="right">
        <script type="text/javascript">
          showSizeCtl();
        </script>
      </td>
    </tr>
  </table>
  </form>
<?
}

?>
